SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[BulkInteractionProcess]
AS
BEGIN
	-- SE USA ESTE SP?
	UPDATE [dbo].[Audio] SET
		[dbo].[Audio].DurationLinguisticTime = [dbo].[#InteractionProcessTemp].DurationLinguisticTime,
		[dbo].[Audio].IsTranscribed = [dbo].[#InteractionProcessTemp].IsTranscribed,
		[dbo].[Audio].IsCancel = [dbo].[#InteractionProcessTemp].IsCancel,
		[dbo].[Audio].[FileName] = [dbo].[#InteractionProcessTemp].[FileName],
		[dbo].[Audio].[ErrorMessage] = [dbo].[#InteractionProcessTemp].[ErrorMessage],
		[dbo].[Audio].LastModifiedDate = GETUTCDATE()
	FROM [dbo].[#InteractionProcessTemp]
	WHERE
		[dbo].[Audio].VCC = [dbo].[#InteractionProcessTemp].VCC
		AND [dbo].[Audio].ID = [dbo].[#InteractionProcessTemp].ID
		AND [dbo].[Audio].Section = [dbo].[#InteractionProcessTemp].Section
		AND [dbo].[Audio].Part = [dbo].[#InteractionProcessTemp].Part

	  UPDATE Process
	  SET [Status] = CASE 
		WHEN total <= transcription + cancel AND cancel > transcription THEN 'FAILED' 
		WHEN total <= transcription + cancel THEN 'COMPLETE' 
		ELSE 'INPROCESS_TRANSCRIPTION' 
		END
	  FROM (
		  SELECT 
			COUNT(1)					total
			,COUNT(C.isCancel)			cancel
			,COUNT(C.IsTranscribed)		transcription 
			,B.ProcessId				processId
			,B.vcc						vcc
		  FROM [ProcessAudio] A (NOLOCK)
		  INNER JOIN (SELECT DISTINCT vcc, processId FROM [#InteractionProcessTemp]) B ON A.[vcc] = B.[vcc] AND A.ProcessId = B.ProcessId 
		  INNER JOIN Audio C (NOLOCK) ON A.VCC = C.VCC AND A.AudioId =C.ID AND ISNULL(A.Section,0) = ISNULL(C.Section,0) AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
		  GROUP BY B.ProcessId, B.vcc
	  ) B
	  WHERE  B.VCC = [Process].VCC AND B.ProcessId = Process.[Name]

	 UPDATE EvaluationPlan
	  set [Status] = 5
	  --SELECT * 
	  FROM EvaluationPlan A (NOLOCK)
	  INNER JOIN Process B (NOLOCK) ON A.Instance = B.Vcc AND A.ProcessId =  B.[Name] AND B.[Status] = 'COMPLETE'
	  WHERE A.Evaluation_Mode = 'A' AND A.FilterByContentQueryName IS NULL AND A.[Status] < 5

	  UPDATE EvaluationPlan
	  set [Status] = 4
	  --SELECT * 
	  FROM EvaluationPlan A (NOLOCK)
	  INNER JOIN Process B (NOLOCK) ON A.Instance = B.Vcc AND A.ProcessId =  B.[Name] AND B.[Status] = 'COMPLETE'
	  WHERE A.Evaluation_Mode = 'A' AND A.FilterByContentQueryName IS NOT NULL AND A.[Status] < 4

	DROP TABLE [dbo].[#InteractionProcessTemp]
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
