SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[GetAbilityEvaluationFormats] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationFormat Varchar(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT AEF.[ID]							'id',
			AEF.[IdEvaluationFormat]		'idEvaluationFormat',
			AEF.[IdAbility]					'idAbility',
			A.[Title]						'titleAbility',
			A.[Detail]						'detailAbility',
			A.[Type]						'abilityType',
			A.[AnalysisType]				'abilityAnalysisType',
			AEF.[IdGroup]					'idGroup',
			G.[Description]                 'descriptionGroup',
			AEF.[IdSubGroup]				'idSubGroup',
			SG.[Description]                'descriptionSubGroup',
			AEF.[Penalizes]					'penalizes',
			AEF.[Score]						'score',
			AEF.[Order]						'order',
			A.[NotApply]					'acceptNotApplies',
			A.[Distribute]					'distribute',
			A.[AcceptComments]				'acceptComments',
			A.[Detail]						'descriptionAbility',
			AEF.[Conditional]				'conditional',
			A.[Query]						'abilityQuery',
			A.QueryName						'query'
		FROM [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		INNER JOIN [dbo].[Group] G (NOLOCK)
			ON G.[Instance] = AEF.[Instance]
				AND G.[ID] = AEF.[IdGroup]
		INNER JOIN [dbo].[SubGroup] SG (NOLOCK)
			ON SG.[Instance] = AEF.[Instance]
				AND SG.[ID] = AEF.[IdSubGroup]
		INNER JOIN [dbo].[Ability] A (NOLOCK)
			ON A.[Instance] = AEF.[Instance]
				AND A.[ID] = AEF.[IdAbility]
		WHERE AEF.[Instance] = @Instance
			AND AEF.[IdEvaluationFormat]= @IdEvaluationFormat
		ORDER BY [Order] ASC
	
	/* DEPRECATED
	SELECT
		A.[ID]							'id',
		A.[IdEvaluationFormat]			'idEvaluationFormat',
		A.[IdAbility]					'idAbility',
		AB.[Title]						'titleAbility',
		AB.[Detail]						'detailAbility',
		AB.[Type]						'abilityType',
		AB.[Query]						'abilityQuery',
		A.[IdGroup]						'idGroup',
		G.[Description]                 'descriptionGroup',
		A.[IdSubGroup]					'idSubGroup',
		S.[Description]                 'descriptionSubGroup',
		A.[Penalizes]					'penalizes',
		A.[Score]						'score',
		A.[Order]						'order',
		AB.[NotApply]					'acceptNotApplies',
		AB.[AcceptComments]				'acceptComments',
		AB.[Detail]						'descriptionAbility',
		A.[Conditional]					'conditional',
        AB.QueryName					'query'
	FROM [SubGroup] S (NOLOCK)
	full join [AbilityEvaluationFormat] A (NOLOCK)
		on S.ID=A.IdSubGroup, [Ability] AB (NOLOCK),
		 [Group] G (NOLOCK)
	WHERE A.[Instance] = @Instance
		AND S.[Instance] = @Instance
		AND G.[Instance] = @Instance
		AND AB.[Instance] = @Instance
		AND A.IdAbility=AB.ID
		AND A.IdGroup=G.ID
		AND A.[IdEvaluationFormat]= @IdEvaluationFormat
	ORDER BY [Order] ASC
	*/
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
