SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetAbilitys] (
	@Instance Varchar(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL, 
	@Disabled bit = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		a.ID							'id',
		a.Title							'title',
		a.Detail						'detail',
		a.[Type]						'type',
		a.Binary						'binary',
		a.NotApply						'notApply',
		a.AcceptComments				'acceptComments',
		a.CreatedDate					'createdDate',
		a.CreatedByUserId				'createdByUserId',
		a.LastModifiedDate  			'lastModifiedDate',
		a.LastModifiedByUserId			'lastModifiedByUserId',
		a.[Enabled]						'enabled',
		a.[Query]						'query',
		a.[Queryname]                   'queryName',
		N.[Culture]						'culture'
	FROM Ability a (NOLOCK)
	LEFT JOIN [dbo].[NLU] N (NOLOCK)
		ON N.[VCC] = A.[Instance]
			AND N.[Name] = SUBSTRING(A.[Query], 0, CHARINDEX('|', A.[Query]))
	WHERE a.Instance = @Instance
		AND ISNULL(a.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(a.Title, '') LIKE CASE WHEN @SearchCriteria = 'title' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
		AND ISNULL(a.Detail, '') LIKE CASE WHEN @SearchCriteria = 'detail' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
		AND ISNULL(@Disabled, 0) <> [Enabled]
	ORDER BY a.[Title]

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
