SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAgents] (
	@VCC VARCHAR(50) = NULL,
	@AgentIds VARCHAR(MAX) = NULL
) AS 
BEGIN 
    SET NOCOUNT ON

	-- DECLARAMOS LA VARIABLES PARA LA QUERY A EJECUTAR
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	-- ARMAMOS LA CONSULTA SIMPLE
	SET @SQL_SELECT += '
		SELECT A.[AgentId]												''agentId'',
				A.[Name]												''name'' '

	-- AGREGAMOS LA TABLA DE BUSQUEDA
	SET @SQL_FROM += '
			FROM [dbo].[Agent] A (NOLOCK) '

	-- 
	SET @SQL_FILTER += '
			WHERE A.[VCC] = ''' + @VCC + ''' '

	-- AGREGAMOS LOS FILTROS
	IF (@AgentIds IS NOT NULL AND @AgentIds != '') 
		-- FILTRAMOS LOS AGENTES QUE SE MODIFICARON HACE MAS DE 7 DIAS PARA ACTUALIZARLOS EN CASO SEA NECESARIO
		SET @SQL_FILTER += '
				AND A.[AgentId] IN (SELECT Value FROM [dbo].[split](''' + @AgentIds + ''','',''))
				AND DATEDIFF(SECOND, A.[TimeStamp], GETUTCDATE()) <= 5 '

	-- JUNTAMOS LAS PARTES DE LA CONSULTA
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL_SELECT)
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
