SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAuditorsEvaluationPlan] (
	@Instance Varchar(50) = NULL,
	@idEvaluationPlan Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		AEP.[IdEvaluationPlan] 'idEvaluationPlan',
		AEP.[IdAuditor] 'idAuditor',
		A.[Description] 'descriptionAuditor',
		COUNT(AEP.IdInteraction) 'numberInteractions'
	FROM
		[AuditorEvaluationPlan] (NOLOCK) AEP
		,[Auditor] (NOLOCK) A
	WHERE
		AEP.[IdAuditor] = A.[ID]
		AND AEP.[Instance] = @Instance
		AND AEP.[IdEvaluationPlan] = @idEvaluationPlan
	GROUP BY
		AEP.[IdEvaluationPlan],
		AEP.[IdAuditor],
		A.[Description]

	SET NOCOUNT OFF
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
