SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetCampaignQualificationAverage] (
	@Instance Varchar(50) = NULL,
	@IdCampaign Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		ERCQS.EvaluationResultCampaignQualificationSum/ERCQ.EvaluationResultCampaignQuantity CampaignQualificationAverage
	FROM
		(
			-- EvaluationResultCampaignQualificationSum
			SELECT
				SUM([QualificationSum]) EvaluationResultCampaignQualificationSum
			FROM
				(
					SELECT
						SUM([Qualification]) QualificationSum
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdCampaign]= @IdCampaign
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction]
				) EvaluationResultCampaign
		) ERCQS,
		(
			-- EvaluationResultCampaignQuantity
			SELECT
				COUNT(*) EvaluationResultCampaignQuantity
			FROM
				(
					SELECT
						[IdCampaign]
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdCampaign]= @IdCampaign
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction],
						[IdCampaign]
				) EvaluationResultCampaign
		) ERCQ

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
