SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetDomains](
	@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[Domain]						'domain',
		[Description]					'description',
		[Client]						'client',
		[HasHttps]						'hasHttps',
		[ContentPort]					'contentPort',
		[Prefix]						'prefix',
		[IsMainDomain]					'isMainDomain',
		[IsContentDomain]				'isContentDomain',
		[ContentDefaultRedirect]		'contentDefaultRedirect',
		[IsDistributedService]			'isDistributedService',
		[AssociatedDistributedService]	'associatedDistributedService',
		[CustomCode]					'customCode',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [Domain] (NOLOCK)
	WHERE [VCC] = @VCC
	AND ISNULL([Domain], '') LIKE CASE WHEN @SearchCriteria = 'domain' THEN '%' + @SearchExpression + '%' ELSE '%' END
	AND ISNULL([Client], '') LIKE CASE WHEN @SearchCriteria = 'client' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
