SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationFormatAttachedSignatures] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- LOS FORMATOS CREADOS PREVIAMENTE A LA IMPLEMENTACION DE FIRMAS ADJUNTAS NO RETORNAN RESULTADO
	IF EXISTS(
		SELECT 1
			FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
			WHERE (
				(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
				OR
				(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
			)
	)
	BEGIN

		SELECT --EFAS.[VCC]							'vcc',
				EFAS.[Description]					'description',
				EFAS.[EvaluationFormatId]			'evaluationFormatId',
				EFAS.[Order]						'order'
			FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
			WHERE (
				(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
				OR
				(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
			)
			ORDER BY EFAS.[Order] ASC
	END
	ELSE
	BEGIN
		-- LLAMAMOS POR DEFECTO LOS REGISTROS DE SYSTEM
		SELECT EFAS.[Description]					'description',
				EFAS.[EvaluationFormatId]			'evaluationFormatId',
				EFAS.[Order]						'order'
		FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
		WHERE EFAS.[VCC] = 'system' 
			AND EFAS.[EvaluationFormatId] IS NULL
		ORDER BY EFAS.[Order] ASC
	END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
