SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationPlanAbilityGenericQueryTask] (
    @VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL
)
AS
BEGIN
SET NOCOUNT ON
	/*
	SELECT DISTINCT
			C.Instance			'vcc'
			,C.QueryName		'name'
		FROM [EvaluationPlan] A (NOLOCK)
		INNER JOIN [AbilityEvaluationFormat] B (NOLOCK)  
			ON A.Instance = B.Instance 
				AND A.IdEvaluationFormat = B.IdEvaluationFormat
		INNER JOIN [Ability] C (NOLOCK)  
			ON A.Instance = C.Instance 
				AND B.IdAbility = C.Id 
				AND C.QueryName IS NOT NULL
		INNER JOIN [dbo].[GenericQuery] D (NOLOCK) 
			ON A.Instance = D.vcc 
			AND D.[Name] = C.[QueryName]
		WHERE A.[Instance] = @VCC
			AND A.[ID] = @ID
	*/

	-- ESTE SP RETORNA LAS GENERICQUERY ASOCIADAS A UN PLAN POR MEDIO DEL FORMATO Y SUS HABILIDADES
	SELECT DISTINCT
			A.[Instance]			'vcc'
			,AQ.[QueryId]			'name'
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)  
			ON EP.[Instance] = AEF.[Instance] 
				AND EP.[IdEvaluationFormat] = AEF.IdEvaluationFormat
		INNER JOIN [dbo].[Ability] A (NOLOCK)  
			ON A.[Instance] = EP.[Instance]
				AND AEF.[IdAbility] = A.[Id] 
				AND (
					A.[Type] = 'MANUAL_AUTOMATIC'
					OR
					A.[Type] = 'MIXED' -- PROXIMA IMPLEMENTACION
				)
				--AND A.[AnalysisType] = 'SEMANTIC'
		INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
			ON AQ.[VCC] = EP.[Instance]
				AND AQ.[AbilityId] = A.[ID]
		INNER JOIN [dbo].[GenericQuery] GQ (NOLOCK) 
			ON EP.[Instance] = GQ.[vcc] 
			AND GQ.[Name] = AQ.[QueryId]
		WHERE EP.[Instance] = @VCC
			AND EP.[ID] = @ID

SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
