SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationPlanCognitiveInteractionTask] (
    @VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL -- EVALUATION PLAN ID
)
AS
BEGIN
SET NOCOUNT ON

	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO CALL QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance					'vcc'
			,EP.ProcessId				'processId'
			,'EVALUATION_PLAN'			'batchTypeName'
			,AU.Campaign				'campaign'
			,IEP.[InteractionType]		'interactionType'
			,EP.[Id]					'evaluationPlanId'
			,IEP.IdInteraction			'id'
			,AU.Section					'section'
			,AU.Part					'part'
			,NULL						'folder'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,AU.[FileName]				'fileName'
			--,F.[cognitiveId]			-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]		'cognitiveEngine'
			,STUFF(
				(
					SELECT DISTINCT ',' + AEF_INNER.[IdAbility]
						FROM [dbo].[AbilityEvaluationFormat] AEF_INNER (NOLOCK)
						INNER JOIN [dbo].[AbilityQuery] AQ_INNER (NOLOCK)
							ON AQ_INNER.[VCC] = AEF_INNER.[Instance]
								AND AQ_INNER.[AbilityId] = AEF_INNER.[IdAbility]
						WHERE AEF_INNER.[Instance] = EP.[Instance]
							AND AEF_INNER.[IdEvaluationFormat] =  EP.[IdEvaluationFormat]
							AND AQ_INNER.[QueryContent] LIKE CONCAT(F.[nluId], '|%')
					FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, ''
			)							'abilities'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON IEP.Instance = EP.Instance 
			AND IEP.IdEvaluationPlan = EP.Id
	INNER JOIN [dbo].[Audio] AU (NOLOCK) 
		ON AU.VCC = EP.Instance
			AND AU.ID = IEP.IdInteraction 
	INNER JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
		ON AEF.Instance = EP.Instance
			AND AEF.IdEvaluationFormat = EP.IdEvaluationFormat 
	INNER JOIN [Ability] AB (NOLOCK) 
		ON AB.Instance = EP.Instance 
			AND AB.ID = AEF.IdAbility 
			AND AB.[AnalysisType] IS NOT NULL
	INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK) 
		ON AQ.[VCC] = EP.[Instance]
			AND AQ.[AbilityId] = AB.[ID]
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON F.[VCC] = EP.[Instance]
			AND F.[cognitiveId] = AQ.[QueryContent] 
			AND F.[intentId] = AQ.[QueryId] 
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @ID
	
	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO TEXT QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance					'vcc'
			,EP.ProcessId				'processId'
			,'EVALUATION_PLAN'			'batchTypeName'
			,AI.[Campaign]				'campaign'
			,IEP.[InteractionType]		'interactionType'
			,EP.[Id]					'evaluationPlanId'
			,IEP.IdInteraction			'id'
			,NULL						'section'
			,NULL						'part'
			,AI.[EndDate]				'endDate'
			,AI.[Folder]				'folder'
			,AI.[DispositionCode]		'dispositionCode'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,AI.[FileName]				'fileName'
			--,F.[cognitiveId]			-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]		'cognitiveEngine'
			,STUFF(
				(
					SELECT DISTINCT ',' + AEF_INNER.[IdAbility]
						FROM [dbo].[AbilityEvaluationFormat] AEF_INNER (NOLOCK)
						INNER JOIN [dbo].[AbilityQuery] AQ_INNER (NOLOCK)
							ON AQ_INNER.[VCC] = AEF_INNER.[Instance]
								AND AQ_INNER.[AbilityId] = AEF_INNER.[IdAbility]
						WHERE AEF_INNER.[Instance] = EP.[Instance]
							AND AEF_INNER.[IdEvaluationFormat] =  EP.[IdEvaluationFormat]
							AND AQ_INNER.[QueryContent] LIKE CONCAT(F.[nluId], '|%')
					FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, ''
			)							'abilities'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON EP.Instance = IEP.Instance 
			AND EP.Id = IEP.IdEvaluationPlan
	INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK) 
		ON EP.Instance = AI.VCC 
			AND IEP.IdInteraction = AI.ID
			AND IEP.FormattedEndDate = AI.Folder
	INNER JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
		ON EP.Instance = AEF.Instance 
			AND EP.IdEvaluationFormat = AEF.IdEvaluationFormat
	INNER JOIN [Ability] AB (NOLOCK)
		ON EP.Instance = AB.Instance 
			AND AEF.IdAbility = AB.ID 
			AND AB.[AnalysisType] IS NOT NULL
	INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK) 
		ON AQ.[VCC] = EP.[Instance]
			AND AQ.[AbilityId] = AB.[ID]
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON F.[VCC] = EP.[Instance]
			AND F.[cognitiveId] = AQ.[QueryContent] 
			AND F.[intentId] = AQ.[QueryId] 
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @ID

SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
