SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationPlansByStatus] (
	@Instance           Varchar(50) = NULL,
	@Status				Numeric(3) = NULL,
	@Disabled			bit = NULL
)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT
		e.[ID]							'id',
		e.[Modality]					'modality',
		e.[DateFin]						'dateFin',
		e.CreatedDate					'createdDate',
		e.CreatedByUserId				'createdByUserId',
		e.LastModifiedDate				'lastModifiedDate',
		e.LastModifiedByUserId			'lastModifiedByUserId',
		e.Description					'description',
		e.IdEvaluationFormat            'idEvaluationFormat',
		e.Enabled						'enabled',
		e.Status						'status',
        e.Evaluation_Mode				'evaluation_mode',
        e.processId    				    'processId',
        e.FilterByContent				'filterByContent',
        e.EvaluatePercentage			'evaluatePercentage',
        e.ProcessAndEvaluate    		'processAndEvaluate',
        ef.templateId    				'templateId',
		count(a.IdInteraction)			'totalEvaluations',
		sum(cast(a.Completed as int))   'completedEvaluations',
		ROUND(sum(cast(a.Completed as numeric(5,2)))*100/count(Distinct a.IdInteraction),2) 'completedPercentage'
	FROM
	    EvaluationPlan e, AuditorEvaluationPlan a, EvaluationFormat ef (NOLOCK)
	WHERE
		e.Instance = @Instance
		AND e.IdEvaluationFormat=ef.id
		AND a.IdEvaluationPlan=e.ID
		AND e.[Status] = @Status
		AND ISNULL(@Disabled, 0) <> e.Enabled
	GROUP BY e.[ID],e.[Modality],e.[DateFin],e.CreatedDate,e.CreatedByUserId,
			 e.LastModifiedDate,e.LastModifiedByUserId,e.Description,e.IdEvaluationFormat,e.Enabled, e.Status, e.Evaluation_Mode,e.processId,ef.templateId,e.FilterByContent, e.EvaluatePercentage, e.ProcessAndEvaluate
 	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
