SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationResults] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL
) 
AS
BEGIN
	SET NOCOUNT ON

	-- SP PARA SOLICITAR LOS RESULTADOS DE LA EVALUACION DE UNA INTERACCION POR VCC, PLAN Y AUDITOR 
	SELECT ER.[IdAbility]							'idAbility',
			A.[Type]								'abilityType',
			ER.[Qualification]						'qualification',
			ER.[ScoreDescription]					'scoreDescription',
			ER.[EvaluationDate]						'evaluationDate',
			ER.[AbilityOrder]						'abilityOrder',
			ER.[LastModifiedByUserId]				'lastModifiedByUserId',
			ER.[LastModifiedDate]					'lastModifiedDate'
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		LEFT JOIN [dbo].[Ability] A (NOLOCK) 
			ON A.[Instance] = ER.[Instance]
				AND A.[ID] = ER.[IdAbility]
		WHERE ER.[Instance] = @VCC 
			AND ER.[IdEvaluationPlan] = @EvaluationPlanId
			AND ER.[IdInteraction] = @InteractionId
			AND ER.[IdAuditor] = @AuditorId
		ORDER BY ER.[AbilityOrder] ASC
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
