SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetSubGroups] (
	@Instance Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL, @Disabled bit = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		s.ID							'id',
		s.Description					'description',
		s.CreatedDate					'createdDate',
		s.CreatedByUserId				'createdByUserId',
		s.LastModifiedDate				'lastModifiedDate',
		s.LastModifiedByUserId			'lastModifiedByUserId',
		s.[Enabled]						'enabled'
	FROM SubGroup s (NOLOCK)
	WHERE s.Instance = @Instance
		AND ISNULL(s.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(s.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
		AND ISNULL(@Disabled, 0) <> [Enabled]
	ORDER BY s.Description ASC

	SET NOCOUNT OFF
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
