SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
--exec [GetTemplateThemeItems] 'system',''
CREATE PROCEDURE [dbo].[GetTemplateThemeItems] (
	@VCC Varchar(50) = NULL, 
	@TemplateId Varchar(50) = NULL,
	@TemplateThemeId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
		A.vcc,
		A.[TemplateId]					'templateId',
		A.[TemplateThemeId]				'templateThemeId',
		A.[ID]							'id',
		B.[Query]						'query',
		A.[CreatedDate]					'createdDate',
		A.[CreatedByUserId]				'createdByUserId',
		A.[LastModifiedDate]			'lastModifiedDate',
		A.[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [TemplateThemeItem] A (NOLOCK)
	INNER JOIN [dbo].[GenericQuery] B (NOLOCK) 
		ON B.[VCC] = A.[VCC]
			AND B.[Name] = A.[ID]
	WHERE A.[VCC] = @VCC
		AND A.[TemplateId] = CASE WHEN ISNULL(@TemplateId, '') = '' THEN [TemplateId] ELSE @TemplateId END
		AND A.[TemplateThemeId] = CASE WHEN ISNULL(@TemplateThemeId, '') = '' THEN [TemplateThemeId] ELSE @TemplateThemeId END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
