SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[GetTranscription] 'default', 'F040EA5A-E455-49EC-8A8D-4A4AD13D8786', 0, 0, 'FFB04B5FF6E242098CD31F419CC4E4A3'
CREATE PROCEDURE [dbo].[GetTranscription]
(
	@VCC VARCHAR(50) = NULL,
	@ProcessId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@Section NUMERIC(5, 0),
	@Part NUMERIC(5, 0),
	@Campaign VARCHAR(50) = NULL,
	@Folder VARCHAR(50) = NULL,
	@ID VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- SI INTERACTIONTYPE ES NULL SETTEAMOS COMO CALL
	IF @InteractionType IS NULL SET @InteractionType = 'CALL'

	SELECT
		[VCC]						'vcc',
		[ProcessId]					'processId',
		[InteractionType]			'interactionType',
		[Section]					'section',
		[Part]						'part',
		[Folder]					'folder',
		[Campaign]					'campaign',
		[ID]						'id',
		[Value]						'value',
		[CreatedDate]				'createdDate',
		[CreatedByUserId]			'createdByUserId',
		[LastModifiedDate]			'lastModifiedDate',
		[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [dbo].[Transcription] (NOLOCK)
	WHERE
		[VCC] = @VCC 
		AND [ProcessId] = @ProcessId 
		AND [InteractionType] = @InteractionType
		AND (
			(
				[InteractionType] = 'CALL'
					AND [Section] = @Section 
					AND [Part] = @Part 
			) OR (
				[InteractionType] <> 'CALL'
					-- AND [Folder] = @Folder
					AND [Campaign] = @Campaign
			)
		)
		AND [ID] = @ID

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
