SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[GetUtterancesByInteraction] 'allegro', '{f2c9e160-8eeb-11e9-8562-b65bb2fb6bcb}', 0, 1
CREATE PROCEDURE [dbo].[GetUtterancesByInteraction]
(
	@VCC			VARCHAR(50),
	@AudioId		VARCHAR(50),
	@Section		NUMERIC(5, 0),
	@Part			NUMERIC(5, 0)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]							'vcc',
		[AppId]							'appId',
		[IntentId]						'intentId',
		[AudioId]						'audioId',
		[Section]						'section',
		[Part]							'part',
		[Speaker]						'speaker',
		[AnchorOffset]					'anchorOffset',
		[FocusOffset]					'focusOffset',
		[CurrentTime]					'currentTime',
		[EndCurrentTime]				'endCurrentTime',
		[UtteranceId]					'utteranceId',
		[TextContent]					'textContent',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM
		[dbo].[Utterance] WITH (NOLOCK)
	WHERE
		[VCC] = @VCC
		AND [AudioId] = @AudioId
		AND [Section] = @Section
		AND [Part] = @Part

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
