SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetVCCs] (
	@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[ID]									'id',
		[Description]							'description',
		[Type]									'type',
		[TranscriptionDefaultLanguage]			'transcriptionDefaultLanguage',
		[CognitiveEngine]						'cognitiveEngine',
		[Country]								'country',
		[Language]								'language',
		[TimeZone]								'timeZone',
		[CreatedDate]							'createdDate',
		[CreatedByUserId]						'createdByUserId',
		[LastModifiedDate]						'lastModifiedDate',
		[LastModifiedByUserId]					'lastModifiedByUserId'
	FROM [VCC] (NOLOCK)
	WHERE [VCC] <> 'system'
		AND [VCC] <> 'default'
		AND ISNULL([ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Country], '') LIKE CASE WHEN @SearchCriteria = 'country' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
