SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveEvaluationPlanCompleted] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [dbo].[EvaluationPlan]
		SET [Status] = 7,
			[Percentage] = 1,
			[StatusDescription] = CASE WHEN [ERROR] = 0 THEN 'COMPLETED' ELSE 'COMPLETED_WITH_ERROR' END
		WHERE NOT EXISTS (
			SELECT AEP.[idEvaluationPLan]
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[idEvaluationPlan] = @IdEvaluationPlan
					AND AEP.[Instance] = @Instance
					AND AEP.[Completed] <> 1
					AND AEP.[Status] = 1
			)
			AND [Instance] = @Instance
			AND [ID] = @IdEvaluationPlan

	-- ACTUALIZAMOS EL STATUS DESCRIPTION CUANDO EXISTEN DESCARTADOS
	/*
	UPDATE [dbo].[EvaluationPlan]
		SET [StatusDescription] = 'COMPLETED_WITH_DISCARDED'
		WHERE EXISTS (
				SELECT AEP.[idEvaluationPLan]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE AEP.[idEvaluationPlan] = @IdEvaluationPlan
						AND AEP.[Instance] = @Instance
						AND AEP.[Status] = 0
			)
			AND [Instance] = @Instance
			AND [ID] = @IdEvaluationPlan
			AND (
				[Status] = 7
				OR
				[Status] = 8
			)
	*/

	-- ACTUALIZAMOS EL STATUS DESCRIPTION CUANDO EXISTEN DESCARTADOS
	UPDATE EP 
		SET EP.[StatusDescription] = 'COMPLETED_WITH_DISCARDED',
			--EP.[Total] = INNER_AEP.[Total],
			--EP.[Progress] = INNER_AEP.[Completed] + INNER_AEP.[Discarded]
			EP.[Percentage] = (INNER_AEP.[Completed] + INNER_AEP.[Discarded]) / INNER_AEP.[Total]
		FROM [dbo].[EvaluationPlan] EP 
		INNER JOIN (
			SELECT AEP.[Instance],
					AEP.[idEvaluationPlan],
					COUNT(AEP.[IdInteraction])														'Total',
					COUNT(CASE AEP.[Completed] WHEN 1 THEN 1 ELSE NULL END)							'Completed',
					COUNT(CASE AEP.[Status] WHEN 0 THEN 1 ELSE NULL END)							'Discarded',
					COUNT(CASE 
							WHEN AEP.[Completed] = 0 AND AEP.[Status] = 1 THEN 1 
							ELSE NULL 
							END
					)																				'Pending'
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @Instance
					AND AEP.[idEvaluationPlan] = @IdEvaluationPlan
				GROUP BY AEP.[Instance], AEP.[idEvaluationPlan]
		) INNER_AEP
			ON INNER_AEP.[Instance] = EP.[Instance]
				AND INNER_AEP.[IdEvaluationPlan] = EP.[ID] 
		WHERE EP.[Instance] = @Instance
			AND [ID] = @IdEvaluationPlan
			AND (
				(
					EP.[Status] = 7
					AND 
					INNER_AEP.[Discarded] > 0
				)
				OR
				(
					EP.[Status] = 8
					AND
					INNER_AEP.[Pending] = 0
					AND 
					INNER_AEP.[Total] = INNER_AEP.[Discarded]
				)
			)

	-- ACTUALIZAMOS EL PLAN MANUA DE CREADO A EVALUANDO
	UPDATE [dbo].[EvaluationPlan]
		SET [Status] = 6
		WHERE EXISTS (
			SELECT AEP.[idEvaluationPLan]
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[idEvaluationPlan] = @IdEvaluationPlan
					AND AEP.[Instance] = @Instance
					AND (
						AEP.[Completed] = 1
						OR 
						AEP.[Status] = 0
					)
			)
			AND [Instance] = @Instance
			AND [ID] = @IdEvaluationPlan
			AND [Status] = 1
			AND [Evaluation_Mode] = 'M'

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
