SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveProcessFilter] (
	@VCC Varchar(50) = NULL, 				@ProcessId Varchar(50) = NULL,				@Key Varchar(50) = NULL,
	@Value Varchar(100) = NULL,				@CreatedDate Datetime = NULL,				@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,		@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [ProcessFilter]
	SET [Key] = @Key,
		[Value] = @Value,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [ProcessId] = @ProcessId
	AND [Key] = @Key
	AND [Value] = @Value

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [ProcessFilter] (
			[VCC], [ProcessId], [Key],
			[Value], [CreatedDate], 
			[CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ProcessId, @Key,
			@Value, @CreatedDate,
			@CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE()
		)
	END

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
