SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveProcessSummary] (
	@VCC Varchar(50) = NULL, 					@ProcessId Varchar(50) = NULL,				@SilenceTime Varchar(50) = NULL,
	@AverageSilenceTime Varchar(50) = NULL,		@DurationTime Varchar(50) = NULL,			@AverageDurationTime Varchar(50) = NULL,
	@DurationTimeRate Varchar(50) = NULL,		@CreatedDate Datetime = NULL,				@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,			@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [ProcessSummary]
	SET [SilenceTime] = @SilenceTime,
		[AverageSilenceTime] = @AverageSilenceTime,
		[DurationTime] = @DurationTime,
		[AverageDurationTime] = @AverageDurationTime,
		[DurationTimeRate] = @DurationTimeRate,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [ProcessId] = @ProcessId

    IF @@ROWCOUNT = 0
		INSERT INTO [ProcessSummary] (
			[VCC], [ProcessId], [SilenceTime], [AverageSilenceTime], [DurationTime], [AverageDurationTime],
			[DurationTimeRate], [CreatedDate], [CreatedByUserId],
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ProcessId, @SilenceTime, @AverageSilenceTime, @DurationTime, @AverageDurationTime,
			@DurationTimeRate, @CreatedDate, @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE()
		)
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
