SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[SaveSQLStudyDetail] 'default', '36375C91-8874-4D13-A410-CBB675E1D83F', '8798F2D7-7BE1-40C6-831C-F17683B90929', '/* Sintaxis SQL */', 0
CREATE PROCEDURE [dbo].[SaveSQLStudyDetail]
(
	@VCC					VARCHAR(50),
	@StudyId				VARCHAR(200),
	@TemplateId				VARCHAR(50),
	@SQL					VARCHAR(MAX),
	@Restart				INT

)
AS
BEGIN
	SET NOCOUNT ON

	-- Si llega el parametro que indica que debe reprocesar estudio.
	IF(@Restart = 1)
	BEGIN
		-- Restablecer tablas:
		-- Study
		-- StudyDetail
		-- StudyResultSummary
		-- StudyResultSummaryDetail
		BEGIN
			UPDATE [dbo].[Study] SET
			[Status] = NULL
			WHERE VCC = @VCC
			AND [Name] = @StudyId
		END

		BEGIN
			DELETE FROM [dbo].[StudyDetail]
			WHERE VCC = @VCC
			AND StudyId = @StudyId
		END

		BEGIN
			DELETE FROM [dbo].[StudyResultSummary]
			WHERE VCC = @VCC
			AND StudyId = @StudyId
		END

		BEGIN
			DELETE FROM [dbo].[StudyResultSummaryDetail]
			WHERE VCC = @VCC
			AND StudyId = @StudyId
		END
	END

	-- ContinÃºa ejecucion normal.
	BEGIN
		EXEC(@SQL)
	END
	BEGIN
		INSERT INTO [dbo].[StudyResultSummary] ([VCC], [StudyId], [TemplateId], [TemplateThemeId], [ID], [Description], [Category1], [Category2], [Total], [Duration], [Silence], [Confidence], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
		SELECT B.VCC, B.StudyId, A.TemplateId, A.ID TemplateThemeId, CONVERT(VARCHAR(50), NEWID()) ID, A.Description, A.Category1, A.Category2, 
		COUNT(B.Total) Total, SUM(B.Duration) Duration, SUM(B.Silence) Silence, AVG(B.Confidence) Confidence, A.CreatedDate, A.CreatedByUserId, A.LastModifiedDate, A.LastModifiedByUserId, GETUTCDATE()
		FROM [dbo].[TemplateTheme] A (NOLOCK)
		INNER JOIN [dbo].[StudyDetail] B (NOLOCK) ON A.ID = B.TemplateThemeId
		INNER JOIN [dbo].[Study] S (NOLOCK) ON S.[VCC] = B.[VCC] AND S.[Name] = B.[StudyId]
		LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) ON S.[VCC] = PA.[VCC] AND S.[ProcessId] = PA.[ProcessId] AND B.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		WHERE
			A.VCC IN ('system', @VCC)
			AND B.StudyId = @StudyId
			AND A.TemplateId = @TemplateId
		GROUP BY B.VCC, B.StudyId, A.TemplateId, A.ID, A.Description, A.Category1, A.Category2, A.CreatedDate, A.CreatedByUserId, A.LastModifiedDate, A.LastModifiedByUserId, A.TimeStamp
	END
	BEGIN
		UPDATE [dbo].[Study] SET
		[Status] = 1
		WHERE 
			VCC = @VCC
			AND [Name] = @StudyId
	END
	SELECT 1 AS 'result'

	SET NOCOUNT OFF

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
