SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveTemplateTheme] (
	@VCC Varchar(50) = NULL, 			@TemplateId Varchar(50) = NULL, 		@ID Varchar(200) = NULL,
	@Order Int = NULL,						@Description Varchar(50) = NULL,		@Category1 Varchar(50) = NULL,	
	@Category2 Varchar(50) = NULL,			@CreatedDate Datetime = NULL,			@CreatedByUserId Varchar(50) = NULL, 	
	@LastModifiedDate Datetime = NULL,		@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [TemplateTheme]
	SET [Order] = @Order,
		[Description] = @Description,
		[Category1] = @Category1,
		[Category2] = @Category2,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
	AND [TemplateId] = @TemplateId
	AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [TemplateTheme] (
			[VCC], [TemplateId], [ID], [Order],
			[Description], [Category1], [Category2],
			[CreatedDate], [CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @TemplateId, @ID, @Order,
			@Description, @Category1, @Category2,
			@CreatedDate, @CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE()
		)

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
